10   CLS
20  PRINT "********************************************************************"
30  PRINT "* THIS PROGRAM CALCULATES THE DISTANCE AND LENGTH A SINGLE SHUNT   *"
40  PRINT "*                                                                  *"
50  PRINT "* STUB MUST BE PLACED TO GIVE A PERFECT MATCH TO THE LOAD          *"
60  PRINT "********************************************************************"
70  PRINT
80  PI = 4*ATN(1)
90  REM PROGRAM FOR CALCULATING THE DISTANCE FROM THE LOAD AND LENGTH OF A SINGLE STIB TUNER
100   REM BY MARK R. PERHACS 5-87
110   PRINT "SINGLE STUB MATCHING PROGRAM V1.2"
120   PRINT
130   PRINT "FOR SHORTED OR OPEN, SHUNT CONNECTED STUB OF SAME ZO AS THE MAIN LINE"
140   PRINT
150   INPUT "PLEASE INPUT THE CHARAACTERISTIC IMPEDANCE";ZO
160   PRINT
170  INPUT "PLEASE INPUT THE REAL PART OF THE LOAD";RL :PRINT
180  INPUT "PLEASE INPUT THE IMAGINARY PART OF THE LOAD";IL :PRINT
190  INPUT "PLEASE INPUT THE FREQUENCY OF OPERATION IN HERTZ";F:PRINT
200  IF F = 0 THEN PRINT"YOU DON'T NEED A TRANSMISSION LINE FOR D C":PRINT:END
210  PRINT "THE VELOCITY FACTOR OF MOST STANDARD TRANSMISSION LINES IS APPROX 66%":PRINT
220  PRINT "FOR THE PURPOSE OF THIS PROGRAM THE VELOCITY IS USED TO FIND THE"
230  PRINT
240  PRINT "WAVELENGTH.  YOU MAY CHOOSE IT TO BE  1 FOR FREE SPACE":PRINT
250  INPUT"PLEASE INPUT THE VELOCITY OF YOUR TRANSMISSION LINE IN DECMAL FORM";VP:PRINT
260  CLS
270  REM CALCULATE THE WAVELENGTH
280  C = 9.98E+08
290  IF VP = 0 THEN VP = 0.000999999
300  WL = (C * VP)/F
310  AA = RL- ZO
320  IF AA = 0 THEN AA = 9.9999E-05
330  BB = RL+ZO
340  IF IL = 0 THEN GOTO 450
350  MAG =SQR(AA^2+IL^2)
360  AN = ABS(IL/AA)
370  A1=ATN(AN)
380  A1=(A1*57.2958)
390  MAGN =SQR(BB^2+IL^2)
400  ANG=ABS(IL/BB)
410  A2=ATN(ANG)
420  A2=(A2*57.2958)
430  ANS=MAG/MAGN
440  PHA= A1-A2:GOTO 470
450  GAMMA = (RL-ZO)/(RL+ZO)
460  VSWR = (1+GAMMA)/(1-GAMMA):GOTO 480
470  VSWR = (1+ ANS)/(1-ANS)
480  REM CALCULATE  THE DISTANCE FROM THE LOAD THE STUB MUST BE PLACED
490  X = SQR(VSWR)
500  Y = (2 * 3.1415)/WL
510  Z = ATN(X)
520  DIST = Z/Y
530  REM NORMALIZE WITH RESPECT TO THE SMITH CHART
540  NORMDIST = DIST/WL
550  PRINT"THE STUB SHOULD BE PLACED"NORMDIST"WAVELENGTHS FROM THE LOAD"
560  PRINT:PRINT
570  PRINT "THE VSWR OF YOUR TRANSMISSION LINE IS :";VSWR
580  REM CALCULATE R H S  VSWR
590  Z1 = VSWR * X
600  B1 = SQR(VSWR^2+VSWR)
610  B2 = ABS(X/VSWR)
620  B3 = ATN(B2)
630  B3 = (B3*57.2958)
640  C1 = SQR(1+Z1^2)
650  C2 = ABS(Z1)
660  C3 = ATN(C2)
670  C3 = (C3*57.2958)
680  D1 = B1/C1
690  D2 = B3-C3
700  E1 = WL/(2*PI)
710  E2 = SQR(D1*(D1+1))
720  E3 = D1/ E2
730  L1 = ATN(E3)
740  L2 = (E1*L1)
750  L =L2/360
760  PRINT:PRINT
770  PRINT "WOULD YOU LIKE TO USE AN OPEN SHUNT STUB OR A SHORTED SHUNT STUB?(O/S)"
780  INPUT A$
790  LO = L + 0.25
800  PRINT:PRINT
810  IF A$ = "S" THEN 840
820  PRINT"FOR AN OPEN STUB YOU NEED A LENGTH OF =";LO"WAVELENGTHS":GOTO 860
830  PRINT
840  PRINT "FOR A SHORTED STUB YOU NEED A LENGTH OF =";L"WAVELENGTHS"
850  PRINT
860  INPUT"DO YOU WANT A HARD COPY (Y/N)";H$
870  PRINT
880  IF H$ ="Y" THEN GOTO 890 ELSE END
890  IF A$ = "S" THEN LPRINT"FOR A SHORTED STUB YOU NEED A LENGTH OF ";L"WAVELENGTHS" ELSE LPRINT"FOR AN OPEN STUB YOU NEED A LENGTH OF";L"WAVELENGTHS"
900  END
