10  CLS: PRINT "PROGRAM TO CALCULATE MICROSTRIP CAPACITANCE V1.0I (9/1/86)"
20  PRINT "WRITTEN BY A. KATZ FOR TSC ELECTRONICS PROGRAM SERIES
30  PRINT "ALL DIMENSIONS ARE IN MILLS OR WAVELENGTHS - USE MS-IBM TO CONV": PI=4*ATN(1)
32  PRINT: INPUT "MICROSTRIP OR PARALLEL PLATE CAPACITOR (M/PP)"; T$
34  IF T$="PP" THEN 400 ELSE IF T$<>"M" THEN 32
40  PRINT: INPUT "ANALYSIS OR SYNTHESIS (ANA/SYN)"; Q$
50  IF Q$="ANA" THEN 200 ELSE IF Q$<>"SYN" THEN 40
60  PRINT: INPUT "Z0 OF LINE"; Z0
70  INPUT "FREQ IN MHz"; F: F=F*1E+06
80  INPUT "CAP. PICOFARADS"; CP: X=2*PI*F*CP*0*Z0
90  LM=ATN(X/(1-X*X))/(2*PI): IF LM<0 THEN LM=0.25-LM
100  LC=LM*Z0/(2*F*0): PRINT
110  PRINT "XC/Z0="; 1/X; "MUST BE >> 1 FOR GOOD APPROX, SERIES IND IN nHr="; LC
120  PRINT "LENGTH IN WAVELENGTHS ="; LM
130  PRINT: INPUT "WANT HARDCOPY (Y/N)"; H$
140  IF H$<>"Y" THEN 180
150  LPRINT: LPRINT "LINE Z0 ="; Z0
160  LPRINT: LPRINT "LENGTH IN WAVELENGTHS ="; LM, "SERIES IND="; LC
170  LPRINT: LPRINT "CAP. IN PICOFARADS="; CP
180  INPUT "DO YOU WANT TO TRY OTHER VALUES ( Y OR N)"; Q$
190  IF Q$="Y" THEN 40 ELSE END
200  PRINT: INPUT "Z0 OF LINE"; Z0
210  INPUT "FREQ IN MHz"; F: F=F*1E+06
220  INPUT "LENGTH IN WAVELENGTHS ="; LM
230  BC=1/Z0*SIN(2*PI*LM): LC=LM*Z0/(2*F*0): CP=BC/(2*PI*F*0): PRINT
240  PRINT "CAP PICOFARADS"; CP; " CAP REACTANCE="; 1/BC; " SERIES IND nHr="; LC
250  PRINT: INPUT "WANT HARDCOPY (Y/N)"; H$
260  IF H$<>"Y" THEN 300
270  LPRINT: LPRINT "LINE Z0 ="; Z0
280  LPRINT: LPRINT "LENGTH IN WAVELENGTHS ="; LM, "SERIES IND="; LC
290  LPRINT: LPRINT "CAP. IN PICOFARADS ="; CP, "REACTANCE="; 1/BC
300  INPUT "DO YOU WANT TO TRY OTHER VALUES ( Y OR N)"; Q$
310  IF Q$="Y" THEN 40 ELSE END
400  PRINT: INPUT "ANALYSIS OR SYNTHESIS (ANA/SYN)"; Q$
410  IF Q$="ANA" THEN 500 ELSE IF Q$<>"SYN" THEN 400
420  PRINT: INPUT "CALCULATE SPACING OR SIDE LENGTH (S/L)"; C$
421  IF C$<>"S" AND C$<>"L" THEN 420
422  PRINT: INPUT "CAPACITANCE IN pFd"; CP: CP=CP
424  INPUT "RELATIVE DIELECTRIC CONSTANT"; E
430  IF C$="L" THEN INPUT "SPACING IN MILLS"; D: L=SQR(CP*D/(0.000224999*E)):GOTO 450
440  INPUT "SIDE LENGTH IN MILLS"; L:  A=L^2: D=0.000224999*E*A/CP
450  PRINT: PRINT "CAP pFd=" CP; " ER=" E; " SPACING=" D; " LENGTH=" L
460  PRINT: INPUT "WANT HARDCOPY (Y/N)"; H$
470  IF H$<>"Y" THEN 490
480  LPRINT: LPRINT "CAP IN pFd=" CP; " ER=" E; " SPACING=" D; " LENGTH=" L
490  INPUT "DO YOU WANT TO TRY OTHER VALUES ( Y OR N)"; Q$
495  IF Q$="Y" THEN 32 ELSE END
500  PRINT: INPUT "RELATIVE DIELECTRIC CONSTANT"; E
510  INPUT "SPACING IN MILLS"; D
520  INPUT "SIDE LENGTH IN MILLS"; L:  A=L^2: CP=0.000224999*E*A/D
530  PRINT: PRINT "CAP pFd=" CP; " ER=" E; " SPACING=" D; " LENGTH=" L
540  PRINT: INPUT "WANT HARDCOPY (Y/N)"; H$
550  IF H$<>"Y" THEN 570
560  LPRINT: LPRINT "CAP pFd=" CP; " ER=" E; " SPACING=" D; " LENGTH=" L
570  INPUT "DO YOU WANT TO TRY OTHER VALUES ( Y OR N)"; Q$
580  IF Q$="Y" THEN 32 ELSE END
